import { useContext } from "react";
import { AccessControlContext } from "./AccessControlContext";
import { AccessControlContextValue } from "./types";

export function useAccessControl(): AccessControlContextValue | undefined;
export function useAccessControl(overrides: AccessControlContextValue): AccessControlContextValue;
export function useAccessControl(overrides?: AccessControlContextValue) {
  const fromContext = useContext(AccessControlContext)

  if (fromContext != null) {
    return {
      ...fromContext,
      ...overrides,
    }
  }

  return overrides;
}
