import { To } from "react-router-dom";

type QueryFunctionContext = {
  signal?: AbortSignal;
}

export type WithRedirectTo<P = unknown> = P & {
  redirectTo?: To | false;
};

export type AuthRedirectResult = {
  redirectTo?: To | false;
  logoutOnFailure?: boolean;
};

export interface UserIdentity {
  id: string | number;
  fullName?: string;
  email?: string;
  phoneNumber?: string;
  avatarUrl?: string;
  [key: string]: any;
}

export interface AuthProviderCustoms {}

export interface AuthProvider extends AuthProviderCustoms {
  login: (params: any) => Promise<WithRedirectTo | void | any>;
  logout: (params: any) => Promise<void | false | string>;
  checkAuth: (params: QueryFunctionContext) => Promise<void>;
  checkError: (error: any) => Promise<void>;
  getIdentity?: (params?: QueryFunctionContext) => Promise<UserIdentity>;
  getPermissions: (params: QueryFunctionContext) => Promise<any>;
  handleCallback?: (params?: QueryFunctionContext) => Promise<AuthRedirectResult | void | any>;
}
