import { createContext, PropsWithChildren, useContext } from "react";

const InAdmin = createContext(false);

/**
 * @private
 */
export function InAdminContext(props: PropsWithChildren) {
  return (
    <InAdmin.Provider value={true}>
      {props.children}
    </InAdmin.Provider>
  )
}

/**
 * @private
 */
export function useInAdminContext() {
  return useContext(InAdmin);
}
