import { useTranslate } from "../i18n";
import { TitleProps } from "./types";

export function PageTitle(props: TitleProps) {
  const {
    title,
    defaultTitle,
    className,
    ...rest
  } = props;
  const translate = useTranslate();

  if (!title && !defaultTitle) {
    return null;
  }

  return (
    <span className={className}>
      {!title ? (
        <span {...rest}>{defaultTitle}</span>
      ) : typeof title === 'string' ? (
        <span {...rest}>{translate(title, { _: title })}</span>
      ) : (
        title
      )}
    </span>
  );
}
