import { PageTitle } from './PageTitle';
import { useRecordRepresentation } from '../record';
import { useTranslate } from '../i18n';
import { TitleProps } from './types';

export const PageTitleConfigurable = ({
  preferenceKey,
  title,
  defaultTitle,
  record,
  ...props
}: TitleProps) => {
  const translate = useTranslate();
  const titleFromPreferences = useRecordRepresentation({
    record,
    representation: preferenceKey === false ? undefined : preferenceKey,
  });

  if (titleFromPreferences) {
    return (
      <span className={props.className} {...props}>
        {translate(titleFromPreferences, {
          ...record,
          _: titleFromPreferences,
        })}
      </span>
    )
  }

  return (
    <PageTitle
      title={title}
      defaultTitle={defaultTitle}
      {...props}
    />
  );
};
