import { Portlet } from '../portal';
import { titlePortalName } from './constants';
import { PageTitle } from './PageTitle';
import { PageTitleConfigurable } from './PageTitleConfigurable';
import { TitleProps } from './types';

export const Title = (props: TitleProps) => {
  const {
    defaultTitle,
    title,
    preferenceKey,
    ...rest
  } = props;

  return (
    <Portlet to={titlePortalName}>
      {() => {
        if (!defaultTitle && !title) {
          console.warn('Missing title prop in <Title> element');
        }
        if (preferenceKey === false) {
          return (
            <PageTitle
              title={title}
              defaultTitle={defaultTitle}
              {...rest}
            />
          );
        }
        return (
          <PageTitleConfigurable
            title={title}
            defaultTitle={defaultTitle}
            preferenceKey={preferenceKey}
            {...rest}
          />
        );
      }}
    </Portlet>
  );
};
